import gi
gi.require_version("Gst", "1.0")
from gi.repository import Gst


class Camera():
	def __init__(self, device, camera_number, width, height, framerate, bitrate):
		Gst.init(None)

		self.cmd = f'v4l2src device=/dev/video{camera_number} ! video/x-raw, width={width}, height={height}, framerate={framerate}/1 ! tee name=t t. ! queue ! videoconvert ! v4l2h264enc extra-controls="controls, video_bitrate=7000000, h264_livel=1, h264_profile=9, h264_i_frame_period={framerate}" ! video/x-h264, level=(string)3.1, profile=baseline, alignment=au, stream-format=byte-stream ! h264parse config-interval=1 ! queue leaky=2 ! appsink name=sinkh drop=true sync=false max-buffers=1 emit-signals=true t. ! videoscale ! video/x-raw, width=640, height=480, framerate=30/1 ! queue ! videoconvert ! v4l2h264enc extra-controls="controls, video_bitrate=5000000, h264_livel=1, h264_profile=9, h264_i_frame_period={framerate}" ! video/x-h264, level=(string)3.1, profile=baseline, alignment=au, stream-format=byte-stream ! h264parse config-interval=1 ! queue leaky=2 ! appsink name=sinkm drop=true sync=false max-buffers=1 emit-signals=true t. ! videoscale ! video/x-raw, width=320, height=240, framerate=30/1 ! queue ! videoconvert ! v4l2h264enc extra-controls="controls, video_bitrate=1000000, h264_livel=1, h264_profile=9, h264_i_frame_period={framerate}" ! video/x-h264, level=(string)3.1, profile=baseline, alignment=au, stream-format=byte-stream ! h264parse config-interval=1 ! queue leaky=2 ! appsink name=sinkl drop=true sync=false max-buffers=1 emit-signals=true'
		self.cmd = f"v4l2src device=/dev/video{camera_number} ! video/x-raw, width={width}, height={height}, framerate={framerate}/1 ! tee name=t t. ! queue ! videoconvert ! nvvidconv ! nvv4l2h265enc bitrate=7000000 insert-sps-pps=true idrinterval=30 iframeinterval=30 ! video/x-h265, alignment=au, stream-format=byte-stream ! h265parse config-interval=1 ! queue leaky=2 ! appsink name=sinkh drop=true sync=false max-buffers=3 emit-signals=true t. ! videoscale ! video/x-raw, width=640, height=480, framerate=30/1 ! queue ! videoconvert ! nvvidconv ! nvv4l2h265enc bitrate=3000000 insert-sps-pps=true idrinterval=30 iframeinterval=30 ! video/x-h265, alignment=au, stream-format=byte-stream ! h265parse config-interval=1 ! queue leaky=2 ! appsink name=sinkm drop=true sync=false max-buffers=3 emit-signals=true t. ! videoscale ! video/x-raw, width=320, height=240, framerate=30/1 ! queue ! videoconvert ! nvvidconv ! nvv4l2h265enc bitrate=1000000 insert-sps-pps=true idrinterval=30 iframeinterval=30 ! video/x-h265, alignment=au, stream-format=byte-stream ! h265parse config-interval=1 ! queue leaky=2 ! appsink name=sinkl drop=true sync=false max-buffers=3 emit-signals=true"

		self.pipeline = Gst.parse_launch(self.cmd)
		self.sinkh = self.pipeline.get_by_name("sinkh")
		self.sinkm = self.pipeline.get_by_name("sinkm")
		self.sinkl = self.pipeline.get_by_name("sinkl")
		self.pipeline.set_state(Gst.State.PLAYING)

	def getImageh(self):
		sample = self.sinkh.emit("pull-sample")
		if sample:
			buf = sample.get_buffer()
			image = buf.extract_dup(0, buf.get_size())
			print("Now quality is high, length: ", len(image))
			return image
		else:
			return False

	def getImagem(self):
		sample = self.sinkm.emit("pull-sample")
		if sample:
			buf = sample.get_buffer()
			image = buf.extract_dup(0, buf.get_size())
			print("Now quality is mid, length: ", len(image))
			return image
		else:
			return False

	def getImagel(self):
		sample = self.sinkl.emit("pull-sample")
		if sample:
			buf = sample.get_buffer()
			image = buf.extract_dup(0, buf.get_size())
			print("Now quality is low, length: ", len(image))
			return image
		else:
			return False


