import json
import re

class message():

	def __init__(self, debug):
		self.debug=debug

		# mime data
		self.width=None
		self.height=None
		self.framerate=None
		self.bitrate=None
		self.packet=None

		# json data
		self.ssid=None
		self.password=None
		self.host=None
		self.port=None
		self.path=None
		self.profile=None

		self.url=None
		self.mime=None

		self.mimePattern=r'\{.*?\}'

	def getServer(self, msg):
		try:
			jsonObject = json.loads(msg)
			type = jsonObject.get("type")
			if type == "metric":
				data = jsonObject.get("data")
				if data:
					server = data.get("server")
					if server:
						self.ssid = server.get("ssid")
						self.password = server.get("password")
						self.host = server.get("host")
						self.port = server.get("port")
						self.path = server.get("path")
#						self.profile = server.get("profile")
						self.url = f"ws://{self.host}:{self.port}/{self.path}"

						if self.debug:
							print(f"ssid:{self.ssid}, password:{self.password}, host:{self.host}, port:{self.port}, profile:{self.profile}")
							print(self.url)

						return self.url
					else:
						if self.debug:
							print("Empty Server")
				else:
					if self.debug:
						print("Empty Data")
			else:
				if self.debug:
					print("Empty Type")

		except json.JSONDecodeError as e:
			print(f"JSON Error: {e}, message is '{msg}'")
		except Exception as e:
			print(f"Unknown Error: {e}, message is '{msg}'")

	def decode(self, msg):
		try:
			mime_str = re.findall(self.mimePattern, msg)

			if mime_str:
				for key, val in mime_str:
					if key == "width":
						self.width = val
					elif key == "height":
						self.height = val
					elif key == "framerate":
						self.framerate = val
					elif key == "bitrate":
						self.bitrate = val
					elif key == "packet":
						self.codec = val
				if self.debug:
					print(f"width:{self.width}, height:{self.height}, framerate:{self.framerate}, bitrate:{self.bitrate}")

			else:
				jsonObject = json.loads(msg)
				type = jsonObject.get("type")
				if self.debug:
					print(f"type:{type}")
				if type == "control":
					direction = jsonObject.get("direction")
					if self.debug:
						print(f"direction:{direction}")
					if direction:
						return direction
					else:
						if self.debug:
							print("Empty Direction")

				else:
					if self.debuf:
						print("Empty Type")
		except json.JSONDecodeError as e:
			if self.debug:
				print(f"JSON Error: {e}, message is '{msg}'")
		except Exception as e:
			print(f"Unknown Error: {e}, message is '{msg}'")




