from video import *
import asyncio, websockets, time, json
import sys, os, subprocess

sys.path.append("./ble")
from uart_peripheral import *
from message import *
from control import *
from moth import *


# if you want to restart this code, you can use this function
def restart():
	executable = sys.executable
	args = sys.argv[:]
	args.insert(0, sys.executable)
	os.execvp(executable, args)

# wifi connect function
def wifi_connect(ssid, pwd):
	subprocess.run(['nmcli', 'dev', 'wifi', 'connect', ssid, 'password', pwd])
	print("wifi connected!")


if __name__ == "__main__":
	url = ""
	message = message(True)
	serverdata = main()

	# in main function you can receive the websocket url and wifi setup data
	url = message.getServer(serverdata.server)
	wifi_connect(message.ssid, message.password)

	#Camera(device_name, camera_number, width, height, framerate, bitrate)
	device_name = {"1": "RPi 4", "2": "RPi Zero 2W", "3": "RPi Zero", "4": "Jetson Nano CSI", "5": "Jetson Nano USB", "6": "Jetson Orin Nano", "7": "Jetson Orin NX"}
	cam = Camera(device_name["1"], 1, 640, 480, 30, 5000000)

	# control class init
	control = Control()

	moth = Moth(url, cam, control)
	asyncio.run(moth.start())
