import asyncio, websockets, time, json

class Moth():
	def __init__(self, url, cam, control):
		self.url = url
		self.cam = cam
		self.control = control

	# websocket recv thread
	async def recv(self, ws):
		print("recv")
		while True:
			data = await ws.recv()
			print(data)
			try:
				jsonObject = json.loads(data)				# deserialization data
				direction = jsonObject.get("direction")			# find "direction" & "speed"
				speed = jsonObject.get("speed")
				if direction:
					if speed:
						self.control.control(direction, speed)	# you can check each directions command in file "./control.py"
					else:
						self.control.control_(direction, 255)	# speed range is 0~255
			except:
				pass

	# websocket send thread
	async def send(self, ws):
		print("send")
		# send mime data for decode robot video
		await ws.send(self.cam.mime)
		while True:
			# get image data
			image = self.cam.getImage()
			if image:
				print("Image Length: ", len(image), ", Nal Unit: ", image[10] & 0x1F)
				await ws.send(image)	# send image data
			# you should sleepd this thread for use recv(ws) function
			await asyncio.sleep(0.01)

	# create task and start recv&send thread
	async def start(self):
		async with websockets.connect(self.url, ping_timeout=None)as ws:
			t1 = asyncio.create_task(self.send(ws))
			t2 = asyncio.create_task(self.recv(ws))
			await asyncio.gather(t1, t2)

