#include <fstream>
#include <iostream>
#include <vector>
#include <cstdint>
#include <cstring>
#include <cstdlib>
#include <sstream>
#include <unistd.h>
#include <stdlib.h>
#include <gst/gst.h>
#include <gst/app/app.h>
#include "json.hpp"
#include <websocketpp/config/asio_no_tls_client.hpp>
#include <websocketpp/client.hpp>
#include <chrono>
#include <string>
#include <thread>
#include <array>
#include <memory>

using json=nlohmann::json;
using websocketpp::lib::placeholders::_1;
using websocketpp::lib::placeholders::_2;
using websocketpp::lib::bind;

typedef websocketpp::client<websocketpp::config::asio_client> client;
typedef websocketpp::config::asio_client::message_type::ptr message_ptr;


class CoviewRobot{
public:
	CoviewRobot(int w, int h, int n, int b);
	static GstFlowReturn on_new_sample(GstAppSink*appsink, gpointer user_data);

	static GstFlowReturn on_new_sample_mid(GstAppSink*appsink, gpointer user_data);
	static GstFlowReturn on_new_sample_low(GstAppSink*appsink, gpointer user_data);

	void initWebSocket();
	void on_open(websocketpp::connection_hdl hdl);
	void on_fail(websocketpp::connection_hdl hdl);
	void on_close(websocketpp::connection_hdl hdl);
	void on_message(websocketpp::connection_hdl hdl, message_ptr msg);

	void initPing();
	void ping_open(websocketpp::connection_hdl hdl);
	void ping_fail(websocketpp::connection_hdl hdl);
	void ping_close(websocketpp::connection_hdl hdl);
	void ping_message(websocketpp::connection_hdl hdl, message_ptr msg);

	void initVideo();
	void closeVideo();

	void getProcessUsage(const std::string& command);
	void createCSV();
private:
	std::thread c_thread;
	std::thread c_thread_ping;
	std::string url;
	std::string url_ping;

	std::string exec(const char* cmd);

	client c_ping;
	websocketpp::connection_hdl hdl_ping;
	client c;
	websocketpp::connection_hdl hdl;
	int connection = 0;
	int restart_flag = 0;

	int width;
	int height;
	int num;
	int bitrate;

	int32_t time_=0;

	GstElement *pipeline;
	GstElement *appsink;

	GstElement *appsink_mid;
	GstElement *appsink_low;
	const char fourcc_high[4] = {'R', '1', 'S', 'T'};
	const char fourcc_mid[4] = {'R', '2', 'N', 'D'};
	const char fourcc_low[4] = {'R', '3', 'R', 'D'};
	uint8_t count=0;

	size_t bps = 0;
	double bps_ = 0;
	int err_count_flag = 0;
	int err_count = 0;

	float cpu_total_test = 0.0;
	float mem_total_test = 0.0;
	float cpu_total_test_sub = 0.0;
	float mem_total_test_sub = 0.0;

	std::ofstream file;

	int timeout = 0;

	void writeRow(const std::vector<std::string>& row) {
		for (size_t x = 0; x < row.size(); ++x) {
			file << row[x];
			if (x < row.size() - 1) {
				file << ",";
			}
		}
		file << "\n";
	}

};

